=== debian/changelog ===
libzip (1.11.4-1) unstable; urgency=medium

  * Uploading to unstable after the release

 -- Florian Ernst <florian@debian.org>  Thu, 21 Aug 2025 18:31:58 +0200

libzip (1.11.4-1~exp1) experimental; urgency=medium

  * [f867a7e] New upstream version 1.11.4
  * [f3add00] d/control: Standards-Version: 4.7.2 (no changes required)
  * [39ec5f4] d/libzip-dev.install: add new man5 manpages

 -- Florian Ernst <florian@debian.org>  Wed, 28 May 2025 18:37:55 +0200
