=== debian/watch ===
version=4
https://libzip.org/download/libzip-(.*)\.tar\.xz
